## org.exist.storage
Class NativeClusterBroker

    java.lang.Object
      java.util.Observable
          org.exist.storage.DBBroker
              org.exist.storage.NativeBroker
                  org.exist.storage.NativeClusterBroker

public class NativeClusterBroker
extends NativeBroker

Created by Francesco Mondora.

Author:
  Francesco Mondora aka Makkina, Michele Danieli aka mdanieli Date: 13-dic-2004 Time: 17.12.51 Revision $Revision: 3457 $

Nested Class Summary

Nested classes inherited from class org.exist.storage.NativeBroker
`NativeBroker.NodeRef`

Field Summary

Fields inherited from class org.exist.storage.NativeBroker

`BUFFERS, COLLECTIONS_DBX, COLLECTIONS_DBX_ID, DEFAULT_DATA_DIR, DEFAULT_INDEX_DEPTH, DEFAULT_MIN_MEMORY, DEFAULT_NODES_BEFORE_MEMORY_CHECK, DEFAULT_PAGE_SIZE, DEFAULT_VALUE_CACHE_GROWTH, DEFAULT_VALUE_KEY_THRESHOLD, DEFAULT_VALUE_VALUE_THRESHOLD, DEFAULT_WORD_CACHE_GROWTH, DEFAULT_WORD_KEY_THRESHOLD, DEFAULT_WORD_VALUE_THRESHOLD, DOM_DBX, DOM_DBX_ID, ELEMENTS_DBX, ELEMENTS_DBX_ID, PREPEND_DB_ALWAYS, PREPEND_DB_AS_NEEDED, PREPEND_DB_NEVER, PROPERTY_INDEX_DEPTH, PROPERTY_MIN_FREE_MEMORY, PROPERTY_PAGE_SIZE, TEMP_FRAGMENT_TIMEOUT, VALUES_DBX, VALUES_DBX_ID, VALUES_QNAME_DBX, VALUES_QNAME_DBX_ID, WORDS_DBX, WORDS_DBX_ID`

Fields inherited from class org.exist.storage.DBBroker
`COLLECTION_CONFIG_FILENAME, CONFIG_COLLECTION, customProperties, MATCH_EXACT, MATCH_REGEXP, MATCH_WILDCARDS, NATIVE, NATIVE_CLUSTER, PROPERTY_XUPDATE_CONSISTENCY_CHECKS, PROPERTY_XUPDATE_FRAGMENTATION_FACTOR, PROPERTY_XUPDATE_GROWTH_FACTOR, ROOT_COLLECTION, ROOT_COLLECTION_NAME, SYSTEM_COLLECTION, TEMP_COLLECTION`

Constructor Summary
`NativeClusterBroker(BrokerPool pool, Configuration config)`

Method Summary
`int` `getBackendType()`
`Collection` `getOrCreateCollection(Txn transaction, XmldbURI name)` get collection object If the collection does not yet exists, it is created automatically.
`Collection` `openCollection(XmldbURI name, long addr, int lockMode)` Get collection object.
`void` `saveCollection(Txn transaction, Collection collection)` Saves the specified collection to storage.
`void` `sync(int syncEvent)` Sync dom and collection state data (pages) to disk.

Methods inherited from class org.exist.storage.NativeBroker

`addContentLoadingObserver, addObserver, checkXMLResourceConsistency, checkXMLResourceTree, cleanUpTempCollection, cleanUpTempResources, cleanUpTempResources, clearContentLoadingObservers, closeDocument, copyCollection, copyXMLResource, defragXMLResource, deleteObservers, dropCollectionIndex, endElement, endRemove, flush, getAllXMLResources, getBinaryResource, getCollection, getCollection, getCollectionResources, getDOMFile, getDOMIterator, getElementIndex, getFreeCollectionId, getFreeResourceId, getIndexConfiguration, getNextCollectionId, getNextResourceId, getNodeIterator, getNodesEqualTo, getNodeValue, getPageSize, getQNameValueIndex, getResourceMetadata, getSerializer, getStorage, getStorageFileIds, getTextEngine, getValueIndex, getXMLResource, getXMLResource, getXMLResourcesByDoctype, indexNode, indexNode, insertNodeAfter, isReadOnly, moveCollection, moveXMLResource, newSerializer, objectWith, objectWith, openCollection, prepend, readBinaryResource, reindexCollection, reindexCollection, reindexCollection, removeAllNodes, removeBinaryResource, removeCollection, removeContentLoadingObserver, removeNode, removeXMLResource, repair, shutdown, storeBinaryResource, storeBinaryResource, storeNode, storeTempResource, storeXMLResource, updateNode`

Methods inherited from class org.exist.storage.DBBroker
`backupSymbolsTo, decReferenceCount, endElement, getBrokerPool, getConfiguration, getDOMIterator, getId, getReferenceCount, getSymbols, getUser, getXQueryService, incReferenceCount, indexNode, isCaseSensitive, removeXMLResource, setId, setUser, storeNode, toString`

Methods inherited from class java.util.Observable
`countObservers, deleteObserver, hasChanged, notifyObservers, notifyObservers`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### NativeClusterBroker

    public NativeClusterBroker(BrokerPool pool,
                               Configuration config)
                        throws EXistException

Method Detail

### openCollection

    public Collection openCollection(XmldbURI name,
                                     long addr,
                                     int lockMode)

  Get collection object. If the collection does not exist, null is returned. Wraps for cluster the resultant collection in a ClusterCollection

  Overrides:
    `openCollection` in class `NativeBroker`
  Parameters:
    `name` - Description of the Parameter
  Returns:
    The collection value

### saveCollection

    public void saveCollection(Txn transaction,
                               Collection collection)
                        throws PermissionDeniedException

  Description copied from class: `NativeBroker`
  Saves the specified collection to storage. Collections are usually cached in memory. If a collection is modified, this method needs to be called to make the changes persistent. Note: appending a new document to a collection does not require a save.

  Overrides:
    `saveCollection` in class `NativeBroker`
  Throws:
    `PermissionDeniedException`

### getOrCreateCollection

    public Collection getOrCreateCollection(Txn transaction,
                                            XmldbURI name)
                                     throws PermissionDeniedException

  get collection object If the collection does not yet exists, it is created automatically. Wraps for cluster the resultant collection in a ClusterCollection

  Overrides:
    `getOrCreateCollection` in class `NativeBroker`
  Parameters:
    `name` - the collection's name
  Returns:
    The orCreateCollection value
  Throws:
    `PermissionDeniedException` - Description of the Exception

### sync

    public void sync(int syncEvent)

  Description copied from class: `DBBroker`
  Sync dom and collection state data (pages) to disk. In case of `Sync.MAJOR_SYNC`, sync all states (dom, collection, text and element) to disk.

  Overrides:
    `sync` in class `NativeBroker`

### getBackendType

    public int getBackendType()

  Overrides:
    `getBackendType` in class `NativeBroker`

Copyright (C) Wolfgang Meier. All rights reserved.